
package net.mcreator.kool.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.model.geom.ModelLayers;
import net.minecraft.client.model.SlimeModel;

import net.mcreator.kool.entity.PsEntity;

public class PsRenderer extends MobRenderer<PsEntity, SlimeModel<PsEntity>> {
	public PsRenderer(EntityRendererProvider.Context context) {
		super(context, new SlimeModel(context.bakeLayer(ModelLayers.SLIME)), 0.5f);
	}

	@Override
	public ResourceLocation getTextureLocation(PsEntity entity) {
		return new ResourceLocation("kool:textures/entities/slime11.png");
	}

	@Override
	protected boolean isBodyVisible(PsEntity entity) {
		return false;
	}
}
