
package net.mcreator.kool.fluid;

import net.neoforged.neoforge.fluids.BaseFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.kool.init.KoolModItems;
import net.mcreator.kool.init.KoolModFluids;
import net.mcreator.kool.init.KoolModFluidTypes;
import net.mcreator.kool.init.KoolModBlocks;

public abstract class KoolFluidFluid extends BaseFlowingFluid {
	public static final BaseFlowingFluid.Properties PROPERTIES = new BaseFlowingFluid.Properties(() -> KoolModFluidTypes.KOOL_FLUID_TYPE.get(), () -> KoolModFluids.KOOL_FLUID.get(), () -> KoolModFluids.FLOWING_KOOL_FLUID.get())
			.explosionResistance(100f).slopeFindDistance(1).bucket(() -> KoolModItems.KOOL_FLUID_BUCKET.get()).block(() -> (LiquidBlock) KoolModBlocks.KOOL_FLUID.get());

	private KoolFluidFluid() {
		super(PROPERTIES);
	}

	public static class Source extends KoolFluidFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends KoolFluidFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
