
/*
 * MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.kool.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.fml.event.lifecycle.FMLClientSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.material.FlowingFluid;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.ItemBlockRenderTypes;

import net.mcreator.kool.fluid.KoolFluidFluid;
import net.mcreator.kool.KoolMod;

public class KoolModFluids {
	public static final DeferredRegister<Fluid> REGISTRY = DeferredRegister.create(BuiltInRegistries.FLUID, KoolMod.MODID);
	public static final DeferredHolder<Fluid, FlowingFluid> KOOL_FLUID = REGISTRY.register("kool_fluid", () -> new KoolFluidFluid.Source());
	public static final DeferredHolder<Fluid, FlowingFluid> FLOWING_KOOL_FLUID = REGISTRY.register("flowing_kool_fluid", () -> new KoolFluidFluid.Flowing());

	@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD, value = Dist.CLIENT)
	public static class FluidsClientSideHandler {
		@SubscribeEvent
		public static void clientSetup(FMLClientSetupEvent event) {
			ItemBlockRenderTypes.setRenderLayer(KOOL_FLUID.get(), RenderType.translucent());
			ItemBlockRenderTypes.setRenderLayer(FLOWING_KOOL_FLUID.get(), RenderType.translucent());
		}
	}
}
