
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.kool.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;

import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.Registries;

import net.mcreator.kool.KoolMod;

public class KoolModTabs {
	public static final DeferredRegister<CreativeModeTab> REGISTRY = DeferredRegister.create(Registries.CREATIVE_MODE_TAB, KoolMod.MODID);
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> KOOL_ARMOR = REGISTRY.register("kool_armor",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.kool_armor")).icon(() -> new ItemStack(KoolModItems.THEARMOR_BOOTS.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModItems.KOOLARMOR_ARMOR_HELMET.get());
				tabData.accept(KoolModItems.KOOLARMOR_ARMOR_CHESTPLATE.get());
				tabData.accept(KoolModItems.KOOLARMOR_ARMOR_LEGGINGS.get());
				tabData.accept(KoolModItems.KOOLARMOR_ARMOR_BOOTS.get());
				tabData.accept(KoolModItems.THEARMOR_HELMET.get());
				tabData.accept(KoolModItems.THEARMOR_CHESTPLATE.get());
				tabData.accept(KoolModItems.THEARMOR_LEGGINGS.get());
				tabData.accept(KoolModItems.THEARMOR_BOOTS.get());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> FLUID_AND_ITEMS = REGISTRY.register("fluid_and_items",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.fluid_and_items")).icon(() -> new ItemStack(KoolModItems.KOOLBUCKET.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModItems.KOOL_FLUID_BUCKET.get());
				tabData.accept(KoolModItems.KOOLD.get());
				tabData.accept(KoolModItems.RAW_KOOL_ORE.get());
				tabData.accept(KoolModItems.OOOOOOOOOOOOOOOOOOOOOOOOOO.get());
				tabData.accept(KoolModItems.WARERO.get());
				tabData.accept(KoolModItems.ORE_2.get());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> INGREDIENTS = REGISTRY.register("ingredients",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.ingredients")).icon(() -> new ItemStack(KoolModItems.BEEFY_BOY.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModItems.KOOL.get());
				tabData.accept(KoolModItems.ORE_2_INGOT.get());
				tabData.accept(KoolModItems.BEEFY_BOY.get());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> LIGHT_AND_ORE_BLOCKS = REGISTRY.register("light_and_ore_blocks",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.light_and_ore_blocks")).icon(() -> new ItemStack(KoolModBlocks.SMILELIGHTBLOCK.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModBlocks.KOOL_ORE.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_BLOCK.get().asItem());
				tabData.accept(KoolModBlocks.RSRRREORE.get().asItem());
				tabData.accept(KoolModBlocks.ORE_2222.get().asItem());
				tabData.accept(KoolModBlocks.SMILELIGHTBLOCK.get().asItem());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> KOOL_WOOD = REGISTRY.register("kool_wood",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.kool_wood")).icon(() -> new ItemStack(KoolModBlocks.KOOL_WOOD_LOG.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModBlocks.KOOL_WOOD_WOOD.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_LOG.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_PLANKS.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_STAIRS.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_SLAB.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_FENCE.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_FENCE_GATE.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_PRESSURE_PLATE.get().asItem());
				tabData.accept(KoolModBlocks.KOOL_WOOD_BUTTON.get().asItem());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> KOOLTAB = REGISTRY.register("kooltab",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.kooltab")).icon(() -> new ItemStack(Items.NETHERITE_HELMET)).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModBlocks.KOOL_WOOD_LEAVES.get().asItem());
				tabData.accept(KoolModBlocks.OM.get().asItem());
				tabData.accept(KoolModBlocks.OMOM.get().asItem());
			}).withSearchBar().build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> TOOLS = REGISTRY.register("tools",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.tools")).icon(() -> new ItemStack(KoolModItems.KOOLTOOLS_SWORD.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModItems.KOOLTOOLS_PICKAXE.get());
				tabData.accept(KoolModItems.KOOLTOOLS_AXE.get());
				tabData.accept(KoolModItems.KOOLTOOLS_SWORD.get());
				tabData.accept(KoolModItems.KOOLTOOLS_SHOVEL.get());
				tabData.accept(KoolModItems.KOOLTOOLS_HOE.get());
			})

					.build());
	public static final DeferredHolder<CreativeModeTab, CreativeModeTab> ENTITIES = REGISTRY.register("entities",
			() -> CreativeModeTab.builder().title(Component.translatable("item_group.kool.entities")).icon(() -> new ItemStack(KoolModItems.COWWWWWWW_SPAWN_EGG.get())).displayItems((parameters, tabData) -> {
				tabData.accept(KoolModItems.COWWWWWWW_SPAWN_EGG.get());
				tabData.accept(KoolModItems.PS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.BS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.SLIME_SPAWN_EGG.get());
				tabData.accept(KoolModItems.YS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.MS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.RS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.VS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.GS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.D_GS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.CS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.WS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.V_BS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.L_BS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.TS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.G_GS_SPAWN_EGG.get());
				tabData.accept(KoolModItems.L_9076_SPAWN_EGG.get());
			})

					.build());
}
