
package net.mcreator.kool.command;

import net.neoforged.neoforge.event.RegisterCommandsEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.commands.arguments.item.ItemArgument;
import net.minecraft.commands.arguments.coordinates.BlockPosArgument;
import net.minecraft.commands.arguments.EntityArgument;
import net.minecraft.commands.Commands;

import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.arguments.DoubleArgumentType;

@EventBusSubscriber
public class HMCommand {
	@SubscribeEvent
	public static void registerCommand(RegisterCommandsEvent event) {
		event.getDispatcher().register(Commands.literal("hm")

				.then(Commands.argument("player", EntityArgument.player()).then(Commands.argument("message", StringArgumentType.string())))
				.then(Commands.argument("players", EntityArgument.players()).then(Commands.argument("item", ItemArgument.item(event.getBuildContext())).then(Commands.argument("quantity", DoubleArgumentType.doubleArg(0, 6400)))))
				.then(Commands.argument("targets", EntityArgument.entities()).then(Commands.argument("pos", BlockPosArgument.blockPos()))).then(Commands.argument("pos", BlockPosArgument.blockPos()))
				.then(Commands.literal("add").then(Commands.argument("time", DoubleArgumentType.doubleArg(0))))
				.then(Commands.literal("set").then(Commands.literal("day")).then(Commands.literal("noon")).then(Commands.literal("night")).then(Commands.literal("midnight"))));
	}
}
